﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml.Linq;
using Anis.Twitter.Api;
using System.Collections.Specialized;
using System.Web;

namespace Anis.Twitter.Api {
    /// <summary>
    /// 
    /// </summary>
    public class Status {
        public Status() { }

        internal static Status[] CreateStatuses(string xmlStr) {
            List<Status> r = new List<Status>();

            //string xmlStr = Utility.HttpGet(url, queryString, userID, userPass);

            XElement xEle = XElement.Parse(xmlStr);

            var statusElements = from element in xEle.Elements()
                                 where element.Name == "status"
                                 select element;

            foreach(var statusElement in statusElements) {
                r.Add(new Status(statusElement));
            }

            return r.ToArray();
        }

        internal Status(string xmlStr)
            : this(XElement.Parse(xmlStr)) {
        }

        internal Status(XElement xElement) {
            foreach(XElement element in xElement.Elements()) {
                string value = HttpUtility.HtmlDecode(element.Value);
                switch(element.Name.LocalName) {
                case "created_at":
                    this.Created_at = Utility.ConvertDateTime(value);
                    break;
                case "id":
                    int id;
                    int.TryParse(value, out id);
                    this.Id = id;
                    break;
                case "text":
                    this.Text = value;
                    break;
                case "source":
                    this.Source = value;
                    break;
                case "truncated":
                    this.Truncated = value;
                    break;
                case "in_reply_to_status_id":
                    int in_reply_to_status_id;
                    int.TryParse(value, out in_reply_to_status_id);
                    this.In_reply_to_status_id = in_reply_to_status_id;
                    break;
                case "in_reply_to_user_id":
                    int in_reply_to_user_id;
                    int.TryParse(value, out in_reply_to_user_id);
                    this.In_reply_to_user_id = in_reply_to_user_id;
                    break;
                case "favorited":
                    bool favorited;
                    bool.TryParse(value, out favorited);
                    this.Favorited = favorited;
                    break;
                case "user":
                    this.User = new User(element);
                    break;
                }
            }
        }

        //<created_at>Wed Nov 26 07:02:03 +0000 2008</created_at> 
        public DateTime Created_at { set; get; }

        //<id>0000000000</id>
        public int Id { set; get; }

        //<text>HTMLエンコード済み投稿内容</text>
        public string Text { set; get; }

        //<source>クライアント名</source>
        public string Source { set; get; }

        //<truncated>false</truncated>
        public string Truncated { set; get; }

        //<in_reply_to_status_id>0000000000</in_reply_to_status_id> 
        public int In_reply_to_status_id { set; get; }

        //<in_reply_to_user_id>00000000</in_reply_to_user_id> 
        public int In_reply_to_user_id { set; get; }

        //<favorited>false</favorited> 
        public bool Favorited { set; get; }

        public User User { set; get; }
    }
}